=begin
(c) 2010 TIG & Refractive Software
All Rights Reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING,WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Octane  - Exporter / Renderer Tool

Usage: menu File > 'Octane Render...'
       or Context-menu 'Octane Render...'
       or Toolbar 'Octane Render'
       or type 'octane' in the Ruby Console.

It opens the 'Octane Render' dialog, which exports SKP to OBJ/MTL/Textures
format [for Octane], with other camera, sun info etc if desired, it can 
then 'render' an image using Octane, or make an 'animation' of frame images...

Version:

[beta]
1022
a 20100611 First beta release.
b 20100613 Second beta release. Camera location swap y/z fixed. 
           Sun location swap y/z fixed.
           Animations start-frame/end-frame/step from pull-down lists of 
           available Scenes [i.e. without those 'excluded from animation' 
           in the Scene Manager].
c 20100614 Help button added to open OctaneHelp.pdf in Octane folder.
           Animation Start/End/Step pull-downs linked and animation cmd 
           methods fixed.  'Step' not implement yet [always = 1].
           All settings now remembered with Model.
d 20100614 Step now implemented in animation.
e 20100615 UI messages improved. Animation typo error corrected.
f 20100615 Naming of exported texture files now always mimics SUp's tw output.
g 20100616 Mac feedback addressed, somewhat.
h 20100616 Mac execution of command addressed with initial #!/bin/sh ?
i 20100618 Mac commands corrected.  Other minor UI changes for all.
j 20100618 Mac command line escaping \"...\" finally sorted - partially.
k 20100621 Mac command execution fixed.  Mac multi-app _anim \" fixed to "; 
           _anim has own obj/mtl BUT now uses SAME ocs file.
l 20100629 Mac command execution still buggy - further fixes tried [bash].
           Link/Re-link of anim files resolved.
m 20100701 Mac executable path fixed.
n 20100702 file:/// used for Mac executable.
o 20100702 Further tweaks to Mac version for auto-execution of .commands.
p 20100706 Adjustments to Help file path for Mac. Install README added to zip.
           Menu name changed to 'Octane Render'. New ocs creation merged into 
           first render.  New 'folder_browser' added.  Image_output path now 
           correctly remembered with model.
q 20100709 General tidy up.  MTL/Texture image-names now 'tied' to avoid SUp 
           'locale' glitches, where Material Image's name can differ 
           completely from the texturewriter's given name!
r 20100709 Folder Browser fail on non-existent folder fixed and other tidying.
           Error with MTL/image naming in some locales addressed.
           YUI slider js details revised.
s 20100710 All MTL's 'Ks' values zeroed.
t 20100713 Slider js is now fully integrated into dialog.
u 20100715 JS errors with some browsers circumvented.
           Dialog deactivates on Cancel [X].
           Camera.up vector normalization glitch fixed.
v 20100716 JS errors with some browsers/OS circumvented - 'populate' moved 
           from 'body' in .html into <body> header with onLoad="".
w 20100716 The <body onLoad=""> solution that works for PCs is abandoned.  
           The .html's 'populate' script code moved from the <head> area 
           to just after the </body> tag, for cross-platform compatibility. 
x 20100716 Newly made OCS will now 'link' [-l], without a 'relink' [-r].
           Maximum-sample value [-s 4096] removed for single-frame render option.
           The .html's 'populate' script code now moved to just before the 
           </body> tag for cross-platform compatibility.
           Folder-browser code revisited for cross-platform compatibility.
y 20100719 Folder-browser 'populate' code updated for Mac compatibility.
           Ongoing problems with 'populate' running at right time across PC 
           & Mac platforms resolved.  Sun-vector normalization addressed.
           Glitch with lens/focal values from sliders 'to_strings' corrected.
           The 'Default_Material' now uses the current RGB values for MTL file.
           New tooltips, 'Context-menu' item and 'Toolbar' added.
           Dialog background 'rays' added.
z 20100719 In an attempt to get all WIN [PC] and Mac versions compatible 
           the .html etc has been split into versions for each OS.
aa 20100721 Further revisions to the html MAC version to get the dialog to 
            do its 'populate' at the correct time. CSS for MAC fonts improved.
            Dialog fonts etc adjusted to be more cross-platform friendly.
            In addition to Groups & Component-Instances 'Images' are now exported.
bb 20100722 The 'cmd' windows now start minimized in the Taskbar/Dock, and 
            are titled 'Render Cmd' or 'Animation Cmd'.
            More MAC adjustments to resolve 'populate' problems.
            This is an intermediate step with 'annoying messages' for MAC 
            users to assess how the dialog is loading...
cc 20100724 MAC messages removed and more adjustments to MAC 'populate' code 
            to try and resolve MAC dialog problems.
dd 20100725 PC and MAC 'populate' ruby and html code now fully booleaned to avoid MAC glitches.
ee 20100726 Coding and HTML further adjusted for MAC compatibility.
ff 20100727 More coding and HTML adjustments for MAC compatibility.
gg 20100728 Populate method again revised to attempt MAC compatibility.
hh 20100728 Checkboxes streamlined, plus 'gpu' combos [Octane can still freeze!].
ii 20100728 Some .populate. methods reverted/duplicated to attempy MAC compatibility.

Feedback welcome

TIG

=end
###
class Octane

    @@idset = %w(octane_render_binary project_path project_name native_unit_size resolution width height percentage export_camera active_camera lens_aperture_radius lens_aperture_radius_value focal_depth focal_depth_value motion_blur motion_blur_value export_sun_direction light_source gpu_devices gpu_device0 gpu_device1 gpu_device2 gpu_device3 image_output start_frame end_frame step pixel_samples pixs)

	@@dlg=UI::WebDialog.new(" Refractive Software 2010",false,"Octane",600,707,25,25,false) ###true=resizeable

	@@native_unit_size="meters"    
    
	@@resolution="false"
    @@percentage="100%"
    
    @@export_camera="true"
    @@active_camera="from <Current View>"
    @@lens_aperture_radius="false"
    @@lens_aperture_radius_value=1.0
    @@focal_depth="false"
    @@focal_depth_value=5.0
    @@motion_blur="false"
    @@motion_blur_value="Next"
    
    @@export_sun_direction="false"
    @@light_source="Sun from <Current View>"
    
    @@gpu_devices="false"
    @@gpu_device0="false"
    @@gpu_device1="false"
    @@gpu_device2="false"
    @@gpu_device3="false"

    @@image_output=""
    @@start_frame=nil
    @@end_frame=nil
    @@step=nil
    @@pixel_samples="Medium (256 s/px)"
    @@pixel_samples_array=["Very Low (8 s/px)", "Low (32 s/px)", "Medium (256 s/px)", "Medium/High (512 s/px)", "High (1024 s/px)", "Very High (4096 s/px)", "Custom"]
    @@pixs="256"

### end protected

  def initialize

    @msg=""
    @model=Sketchup.active_model
	@sel=@model.selection
    
    @dlg = @@dlg
    
	@octane_render_binary=Sketchup.read_default("Octane", "octane_render_binary", "").tr("\\\\","\\")
    
	@project_path=@model.get_attribute("Octane", "project_path", nil)
	@project_name=@model.get_attribute("Octane", "project_name", nil)
    
	@native_unit_size=@@native_unit_size
        
	@resolution=@model.get_attribute("Octane", "resolution", @@resolution)
    
    @width=@model.get_attribute("Octane", "width", @model.active_view.vpwidth.to_s)
    @height=@model.get_attribute("Octane", "height", @model.active_view.vpheight.to_s)
    @percentage=@model.get_attribute("Octane", "percentage", @@percentage)
    @percentages_array=["100%","75%","50%","25%","Reset"]
       
    @export_camera=@model.get_attribute("Octane", "export_camera", @@export_camera)
    @active_camera=@model.get_attribute("Octane", "active_camera", @@active_camera)
    @lens_aperture_radius=@model.get_attribute("Octane", "lens_aperture_radius", @@lens_aperture_radius)
    @lens_aperture_radius_value=@model.get_attribute("Octane", "lens_aperture_radius_value", @@lens_aperture_radius_value)
    @focal_depth=@model.get_attribute("Octane", "focal_depth", @@focal_depth)
    @focal_depth_value=@model.get_attribute("Octane", "focal_depth_value", @@focal_depth_value)
    @motion_blur=@model.get_attribute("Octane", "motion_blur", @@motion_blur)
    @motion_blur_value=@model.get_attribute("Octane", "motion_blur_value", @@motion_blur_value)
      
    @export_sun_direction=@model.get_attribute("Octane", "export_sun_direction", @@export_sun_direction)
    @light_source=@model.get_attribute("Octane", "light_source", @@light_source)
        
    @gpu_devices=@model.get_attribute("Octane", "gpu_devices", @@gpu_devices)
    @gpu_device0=@model.get_attribute("Octane", "gpu_device0", @@gpu_device0)
    @gpu_device1=@model.get_attribute("Octane", "gpu_device1", @@gpu_device1)
    @gpu_device2=@model.get_attribute("Octane", "gpu_device2", @@gpu_device2)
    @gpu_device3=@model.get_attribute("Octane", "gpu_device3", @@gpu_device3)
       
    @image_output=@model.get_attribute("Octane", "image_output", nil)
    
    self.get_scenes()
    
    @start_frame=nil
    @start_frame=@scenes[0]if @scenes[0]
    if @scenes.include?(@model.get_attribute("Octane", "start_frame", "()"))
      @start_frame=@model.get_attribute("Octane", "start_frame", nil)
    end#if
    @end_frame=nil
    @end_frame=@scenes[1]if @scenes[1]
    if @scenes.include?(@model.get_attribute("Octane", "end_frame", "()"))
      @end_frame=@model.get_attribute("Octane", "end_frame", nil)
    end#if
    @step=@model.get_attribute("Octane", "step", nil)
    
    @pixel_samples=@model.get_attribute("Octane", "pixel_samples", @@pixel_samples)
    @pixel_samples_array=@@pixel_samples_array
    @pixs=@model.get_attribute("Octane", "pixs", @@pixs)

	@dlg.add_action_callback("browse_octane_render_binary") {|d,p|self.browse_octane_render_binary()}
 	@dlg.add_action_callback("browse_project_path") {|d,p|self.browse_project_path()}
    @dlg.add_action_callback("use_existing_project") {|d,p|self.use_existing_project()}
    @dlg.add_action_callback("update_project_name") {|d,p|self.update_project_name()}

    @dlg.add_action_callback("resolution"){|d,p|self.resolution(p)}
    @dlg.add_action_callback("percentage_changed"){|d,p|self.percentage_changed()}
        
    @dlg.add_action_callback("export_camera"){|d,p|self.export_camera(p)}
    @dlg.add_action_callback("set_camera"){|d,p|self.set_camera()}
    @dlg.add_action_callback("lens_aperture_radius"){|d,p|self.lens_aperture_radius(p)}
    @dlg.add_action_callback("focal_depth"){|d,p|self.focal_depth(p)}
    @dlg.add_action_callback("motion_blur"){|d,p|self.motion_blur(p)}
      
    @dlg.add_action_callback("export_sun_direction"){|d,p|self.export_sun_direction(p)}
        
    @dlg.add_action_callback("gpu_devices"){|d,p|self.gpu_devices(p)}
    @dlg.add_action_callback("gpu_device0"){|d,p|self.gpu_device0(p)}
    @dlg.add_action_callback("gpu_device1"){|d,p|self.gpu_device1(p)}
    @dlg.add_action_callback("gpu_device2"){|d,p|self.gpu_device2(p)}
    @dlg.add_action_callback("gpu_device3"){|d,p|self.gpu_device3(p)}
        
	@dlg.add_action_callback("export"){|d,p|self.export()}
	@dlg.add_action_callback("render"){|d,p|self.render()}
        
    @dlg.add_action_callback("select_image_output"){|d,p|self.select_image_output()}
    @dlg.add_action_callback("render_animation"){|d,p|self.render_animation()}
    
    @dlg.add_action_callback("update_start"){|d,p|self.update_start()}
    @dlg.add_action_callback("update_end"){|d,p|self.update_end()}
    @dlg.add_action_callback("update_step"){|d,p|self.update_step()}
    
    @dlg.add_action_callback("update_pixs"){|d,p|self.update_pixs()}
    @dlg.add_action_callback("update_pixs_txt"){|d,p|self.update_pixs_txt()}
    
    @dlg.add_action_callback("help"){|d,p|self.help()}
    
    @dlg.add_action_callback("set_button"){|d,p|self.set_button()}
        
	@dlg.add_action_callback("populate"){|d,p|self.populate()}
    
    @dlg.set_on_close{self.deactivate(false)}
    ### 
  end

  def activate
    @pc=false
    @pc=true if [PLATFORM].grep(/mswin/)==[PLATFORM]
    ### check on exe
    if @octane_render_binary==""
      UI.messagebox("Octane Render:\nThe 'Octane Render Binary' must be set...")
      self.browse_octane_render_binary()
    elsif not File.exist?(@octane_render_binary.tr("\\","/"))
      UI.messagebox("Octane Render:\nThe 'Octane Render Binary' is not valid...")
      self.browse_octane_render_binary()
    end#if
    @octane_render_binary.tr("/","\\")if @pc
    ### set up project
    @path=@model.path
    if @path==""
       UI.messagebox("Octane Render:\nYou must save this new Sketchup model before using this tool!")
       self.deactivate()
       return nil
    end#if
    ###
    project_path=File.dirname(@path)
    project_name=@model.title.tr(" ","_")
    @project_path=project_path if not @project_path
    @project_name=project_name if not @project_name
    @project_name.tr!(" ","_")
    image_output=@project_path if not @image_output
    @image_name="img00001.png"
    @image_output=File.join(image_output, @image_name) if not @image_output###
    ###
    @project_path.tr!("/","\\")if @pc
    @image_output.tr!("/","\\")if @pc
    ### now do dialog
    @first_time=true
    self.dialog()
  end#activate
  
  def deactivate(open=true)
    self.saveIDvalues()
    begin
      @dlg.close() if open
      @dlgfb.close() if @dlgfb
    rescue
      #puts 'Error closing Octane Render Dialog!'
    end
    Sketchup.send_action("selectSelectionTool:")
    return nil
  end#deactivate
  
  def dialog()
    default_html=File.dirname(__FILE__)+"/OctaneDialog.html"
    ### possible 'locale' language based dialog alternative
    ### e.g. OctaneDialog-ES.html for Spanish version on PC
    locale_html=File.dirname(__FILE__)+"/OctaneDialog-"+Sketchup.get_locale+".html"
    ### remove unused versions of earlier HTMLs ###<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    File.delete(File.dirname(__FILE__)+"/OctaneDialogWIN.html")if File.exist?(File.dirname(__FILE__)+"/OctaneDialogWIN.html")
    File.delete(File.dirname(__FILE__)+"/OctaneDialogMAC.html")if File.exist?(File.dirname(__FILE__)+"/OctaneDialogMAC.html")
    ###
	@dlg=@@dlg unless @dlg
	if File.exist?(locale_html)
      @dlg.set_file(locale_html)
    else
      @dlg.set_file(default_html)
    end#if
    
    ### make dialog for PC or MAC
    @dlg.show{
      sleep(2) if not @pc
      self.populate() ###<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    }
    
    ###
  end#dialog
  
  
  def populate()
    ###return nil
    #set octane_render_binary path
    octane_render_binary=@octane_render_binary.gsub(/\\/){'\\\\'}
    js=("document.getElementById(\"octane_render_binary\").setAttribute(\"value\",\""+octane_render_binary+"\");")
    @dlg.execute_script(js)
    #set project_path
    project_path=@project_path.gsub(/\\/){'\\\\'}
    js=("document.getElementById(\"project_path\").setAttribute(\"value\",\""+project_path+"\");")
    @dlg.execute_script(js)
    #set project_name
    project_name=@project_name
    js=("document.getElementById(\"project_name\").setAttribute(\"value\",\""+project_name+"\");")
    @dlg.execute_script(js)
    #set extg native_unit_size
    units=@model.options["UnitsOptions"]["LengthUnit"]
    case units
      when 1
        @native_unit_size="feet"
      when 2
        @native_unit_size="millimeters"
      when 3
        @native_unit_size="centimeters"
      when 4
        @native_unit_size="meters"
      else ###0
        @native_unit_size="inches"
    end#case
    #set native_units
    units_array=["inches","feet","meters","centimeters","millimeters"]
	units_array.each_with_index do |unit,i|
		js="document.getElementById(\"native_unit_size\")[#{i}] = new Option('#{unit}','#{unit}'"
		js+=",true,true" if @native_unit_size==unit ### SELECTED UNITS
		js+=");"
		@dlg.execute_script(js)
	end#do
    #set resolution
    if @resolution=="true"
      js=("document.getElementById(\"resolution\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"resolution\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width_label\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height_label\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"percentage\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"resolution\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"resolution\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width_label\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height_label\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"percentage\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    # h/w
    if @first_time
      #@width=@model.active_view.vpwidth.to_s
      js=("document.getElementById(\"width\").setAttribute(\"value\",\""+@width+"\");")
      @dlg.execute_script(js)
      #@height=@model.active_view.vpheight.to_s
      js=("document.getElementById(\"height\").setAttribute(\"value\",\""+@height+"\");")
      @dlg.execute_script(js)
    end#if
    @width=@dlg.get_element_value("width")
    @height=@dlg.get_element_value("height")
    if @width.to_i==0 or @height.to_i==0
      @width=@model.active_view.vpwidth.to_s
      @height=@model.active_view.vpheight.to_s
      @percentage="100%"
    end#if
    #set h/w
    js=("document.getElementById(\"width\").setAttribute(\"value\",\""+@width+"\");")
    @dlg.execute_script(js)
    js=("document.getElementById(\"height\").setAttribute(\"value\",\""+@height+"\");")
    @dlg.execute_script(js)
    #set percentage
    @percentage=@dlg.get_element_value("percentage") if not @first_time
	@percentages_array.each_with_index do |p,i|
		js="document.getElementById(\"percentage\")[#{i}] = new Option('#{p}','#{p}'"
		js+=",true,true" if @percentage==p ### SELECTED Percent
		js+=");"
		@dlg.execute_script(js)
	end#do
    @percentage=@dlg.get_element_value("percentage")
    ### always have export_camera set and disabled
    #set export_camera could be omitted as we must always export a camera to render ? NO
    if @export_camera=="true"
      js=("document.getElementById(\"export_camera\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"export_camera\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"active_camera_label\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"active_camera\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"export_camera\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"export_camera\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"active_camera_label\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"active_camera\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    #set active_camera
    @active_camera=@dlg.get_element_value("active_camera") if not @first_time
    @cameras_array=["from <Current View>"]
    ### check for scenes
    @pages=[]
    @model.pages.each{|page|
      name=page.name
      #name=page.label if name != page.label ### in anim only ?
      @pages<< name
    }
    @cameras_array<< "from <Current Scene>" if @pages[0]
    @cameras_array=@cameras_array+@pages
    if not @cameras_array.include?(@active_camera)
      @active_camera=@cameras_array[0]
    end#if
    ###
	@cameras_array.each_with_index do |p,i|
		js="document.getElementById(\"active_camera\")[#{i}] = new Option('#{p}','#{p}'"
		js+=",true,true" if @active_camera==p ### SELECTED camera
		js+=");"
		@dlg.execute_script(js)
	end#do
    @active_camera=@dlg.get_element_value("active_camera")
    #set lens_aperture_radius
    if @lens_aperture_radius=="true"
      js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius_value\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius_value\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    #set lens_aperture_radius
    js=("document.getElementById(\"lens_aperture_radius_value\").setAttribute(\"value\",\""+@lens_aperture_radius_value.to_s+"\");")
    @dlg.execute_script(js)
    #set focal_depth
    if @focal_depth=="true"
      js=("document.getElementById(\"focal_depth\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth_value\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"focal_depth\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth_value\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    #set focal_depth_value
    js=("document.getElementById(\"focal_depth_value\").setAttribute(\"value\",\""+@focal_depth_value.to_s+"\");")
    @dlg.execute_script(js)
    #set motion_blur
    if @motion_blur=="true"
      js=("document.getElementById(\"motion_blur\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
     js=("document.getElementById(\"motion_blur\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"motion_blur_value\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"motion_blur\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"motion_blur\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"motion_blur_value\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    #set motion_blur_value
    @motion_blur_value=@dlg.get_element_value("motion_blur_value") if not @first_time
    motion_blur_array=["Next","Previous"]
	motion_blur_array.each_with_index do |p,i|
		js="document.getElementById(\"motion_blur_value\")[#{i}] = new Option('#{p}','#{p}'"
		js+=",true,true" if @motion_blur_value==p ### SELECTED motion_blur_value
		js+=");"
		@dlg.execute_script(js)
	end#do
    @motion_blur_value=@dlg.get_element_value("motion_blur_value")
    #set export_sun_direction
    if @export_sun_direction=="true"
      js=("document.getElementById(\"export_sun_direction\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"export_sun_direction\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source_label\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"export_sun_direction\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"export_sun_direction\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source_label\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    #set light_sources
    @light_source=@dlg.get_element_value("light_source")
    @lights_array=["Sun from <Current View>"]
    ### check for scenes
    @pages=[]
    @model.pages.each{|page|
      name=page.name
      ###name=page.label if name != page.label
      @pages<< name
    }
    @lights_array<< "Sun from <Current Scene>" if @pages[0]
    @lights_array=@lights_array+@pages
    if not @lights_array.include?(@light_source)
      @light_source=@lights_array[0]
    end#if
    ###
	@lights_array.each_with_index do |p,i|
		js="document.getElementById(\"light_source\")[#{i}] = new Option('#{p}','#{p}'"
		js+=",true,true" if @light_source==p ### SELECTED light
		js+=");"
		@dlg.execute_script(js)
	end#do
    @light_source=@dlg.get_element_value("active_camera")
    #set gpu_devices <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    if @gpu_device0=="true"
      if @gpu_devices=="true"
        js=("document.getElementById(\"gpu_device0\").setAttribute(\"checked\",true);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"true\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device0\").setAttribute(\"disabled\",false);")
        @dlg.execute_script(js)
      else
        js=("document.getElementById(\"gpu_device0\").setAttribute(\"checked\",false);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"false\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device0\").setAttribute(\"disabled\",true);")
        @dlg.execute_script(js)
        @gpu_device0=="false"
      end#if
    else
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
    if @gpu_device1=="true"
      if @gpu_devices=="true"
        js=("document.getElementById(\"gpu_device1\").setAttribute(\"checked\",true);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"true\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device1\").setAttribute(\"disabled\",false);")
        @dlg.execute_script(js)
      else
        js=("document.getElementById(\"gpu_device1\").setAttribute(\"checked\",false);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"false\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device1\").setAttribute(\"disabled\",true);")
        @dlg.execute_script(js)
        @gpu_device1=="false"
      end#if
    else
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
    if @gpu_device2=="true"
      if @gpu_devices=="true"
        js=("document.getElementById(\"gpu_device2\").setAttribute(\"checked\",true);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"true\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device2\").setAttribute(\"disabled\",false);")
        @dlg.execute_script(js)
      else
        js=("document.getElementById(\"gpu_device2\").setAttribute(\"checked\",false);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"false\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device2\").setAttribute(\"disabled\",true);")
        @dlg.execute_script(js)
        @gpu_device2=="false"
      end#if
    else
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
    if @gpu_device3=="true"
      if @gpu_devices=="true"
        js=("document.getElementById(\"gpu_device3\").setAttribute(\"checked\",true);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"true\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device3\").setAttribute(\"disabled\",false);")
        @dlg.execute_script(js)
      else
        js=("document.getElementById(\"gpu_device3\").setAttribute(\"checked\",false);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"false\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"gpu_device3\").setAttribute(\"disabled\",true);")
        @dlg.execute_script(js)
        @gpu_device3=="false"
      end#if
    else
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
    ###
    if @gpu_devices=="true"
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu0\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu1\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu2\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu3\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu0\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu1\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu2\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu3\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      @gpu_device0=="false"
      @gpu_device1=="false"
      @gpu_device2=="false"
      @gpu_device3=="false"
    end#if
    #set image_output
    image_output=@image_output.gsub(/\\/){'\\\\'}
    js=("document.getElementById(\"image_output\").setAttribute(\"value\",\""+image_output+"\");")
    @dlg.execute_script(js)
    #set start_frame etc
    if @start_frame
      @start_frame=@dlg.get_element_value("start_frame") if not @first_time
      self.update_start()
      self.update_end()
      self.update_step()
      js=("document.getElementById(\"start_frame\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"end_frame\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"step\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"start_frame\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"end_frame\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"step\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    ###
    if @end_frame
      self.update_end()
      self.update_step()
      @end_frame=@dlg.get_element_value("end_frame")
      js=("document.getElementById(\"start_frame\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"end_frame\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"step\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"start_frame\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"end_frame\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"step\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    ###
    self.update_step()
    if @step
      @step=@dlg.get_element_value("step")
      js=("document.getElementById(\"start_frame\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"end_frame\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"step\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"start_frame\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"end_frame\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"step\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    ###
    #set pixrelsamples
    @pixel_samples=@dlg.get_element_value("pixel_samples") if not @first_time
    pixel_samples_array=@pixel_samples_array
	pixel_samples_array.each_with_index do |p,i|
		js="document.getElementById(\"pixel_samples\")[#{i}] = new Option('#{p}','#{p}'"
		js+=",true,true" if @pixel_samples==p ### SELECTED pixel_samples
		js+=");"
		@dlg.execute_script(js)
	end#do
    @pixel_samples=@dlg.get_element_value("pixel_samples")
    js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",false);")
    @dlg.execute_script(js)
    ### pixs
    pixsa=@dlg.get_element_value("pixel_samples")
    if pixsa=~/Custom/
      pixs=@pixs
    else
      pixs=pixsa.split("(")[1].to_i.to_s
    end#if    
    js=("document.getElementById(\"pixs\").setAttribute(\"value\",\""+pixs+"\");")
    @dlg.execute_script(js)
    js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",false);")
    @dlg.execute_script(js)
    @pixs==@dlg.get_element_value("pixs")
    ### trap for start_frame etc
    if not @start_frame or not @end_frame or not @step
      js=("document.getElementById(\"pixel_samples\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"pixs\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    ###
    @first_time=false
    ###
  end#populate  
  
  def browse_octane_render_binary()
    Sketchup.set_status_text("Octane Render: Browse for 'Octane Render Binary'...")
    @octane_render_binary=@dlg.get_element_value("octane_render_binary")if @dlg.visible?
    ### browse for file
    binary=UI.openpanel("Choose the 'Refractive Software' - 'Octane Render Binary'...", nil, "*.exe")
    if not binary and not File.exist?(@octane_render_binary.tr("\\","/"))
      UI.messagebox("Octane Render:\nCannot continue without a valid 'Octane Render Binary'!")
      self.deactivate()
      return nil
    end#if
    if binary
      binary.tr!("/","\\")if @pc ### fix for PC openpanel - file seperator on PC = \\, but Mac = /
      @octane_render_binary=binary
      octane_render_binary=binary.gsub(/\\/){'\\\\'}
      Sketchup.write_default("Octane", "octane_render_binary", octane_render_binary)
    end#if
    ###
    octane_render_binary=@octane_render_binary.gsub(/\\/){'\\\\'}
    js=("document.getElementById(\"octane_render_binary\").setAttribute(\"value\",\""+octane_render_binary+"\");")
    @dlg.execute_script(js)
    Sketchup.set_status_text("Octane Render:")
  end#browse_octane_render_binary
  
  def browse_project_path()
    Sketchup.set_status_text("Octane Render: Browse 'Project Path' Folder...")
    ###
    @project_path=@dlg.get_element_value("project_path")if @dlg.visible?
    ### browse for folder
    if File.exist?(@project_path)
      self.startfb(@project_path, "project")
    else
      self.startfb(Dir.pwd, "project")
    end#if
    ###
  end#browse_project_path
  
  def update_project()
    project = @octane_render_folder_browser_result
    #UI.openpanel("Choose any file in a folder to select the 'Project Folder'...", @project_path)
    if not project and not File.exist?(@project_path.tr("\\","/"))
      UI.messagebox("Octane Render:\nCannot continue without a valid 'Project Path'!")
      self.deactivate()
      return nil
    end#if
    @project_path=project
    @project_path.tr!("/","\\")if @pc
    @model.set_attribute("Octane", "project_path", @project_path)
    project_path=@project_path.gsub(/\\/){'\\\\'}
    js=("document.getElementById(\"project_path\").setAttribute(\"value\",\""+project_path+"\");")
    @dlg.execute_script(js)
    ###self.populate()
    Sketchup.set_status_text("Octane Render:")
  end#update_project
  
  def use_existing_project()
    Sketchup.set_status_text("Octane Render: Use Existing Project...")
    ### browse for file
    project=UI.openpanel("Choose 'Existing Project'...", nil, "*.ocs")
    if not project and not File.exist?(@project_path.tr("\\","/"))
      UI.messagebox("Octane Render:\nCannot continue without a valid 'Project Path'!")
      self.deactivate()
      return nil
    end#if
    if project
      @project_path=File.dirname(project.tr("\\","/"))
      @project_path.tr!("/","\\")if @pc
      @model.set_attribute("Octane", "project_path", @project_path)
      @project_name=File.basename(project, ".ocs")
      @project_name.tr!(" ","_")
      @model.set_attribute("Octane", "project_name", @project_name)
    end#if
    project_name=@project_name
    js=("document.getElementById(\"project_name\").setAttribute(\"value\",\""+project_name+"\");")
    @dlg.execute_script(js)
    ###self.populate()
    Sketchup.set_status_text("Octane Render:")
  end#use_existing_project
  
  def update_project_name()
    @project_name=@dlg.get_element_value("project_name")
    @model.set_attribute("Octane", "project_name", @project_name)
  end#update_project_name
  
  def resolution(p)
    @resolution=p
    if @resolution=="true"
      #js=("document.getElementById(\"resolution\").setAttribute(\"checked\",true);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"resolution\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width_label\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height_label\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"percentage\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      #js=("document.getElementById(\"resolution\").setAttribute(\"checked\",false);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"resolution\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width_label\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"width\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height_label\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"height\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"percentage\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    ###self.populate()
  end#resolution
  
  def percentage_changed()
    @percentage=@dlg.get_element_value("percentage")
    ### check if w/h==0 and reset if do...
    if @percentage=="Reset"
      @width=@model.active_view.vpwidth.to_s
      @height=@model.active_view.vpheight.to_s
      @percentage="100%"
    end#if
    # RE-set percentage
	@percentages_array.each_with_index do |p,i|
		js="document.getElementById(\"percentage\")[#{i}] = new Option('#{p}','#{p}'"
		js+=",true,true" if @percentage==p ### SELECTED Percent
		js+=");"
		@dlg.execute_script(js)
	end#do
    @percentage=@dlg.get_element_value("percentage")
    ### update width/height by %
    @width=(@width.to_i * @percentage.to_i / 100).to_i.to_s
    js=("document.getElementById(\"width\").setAttribute(\"value\",\""+@width+"\");")
    @dlg.execute_script(js)
    @height=(@height.to_i * @percentage.to_i / 100).to_i.to_s
    js=("document.getElementById(\"height\").setAttribute(\"value\",\""+@height+"\");")
    @dlg.execute_script(js)
    ###self.populate()
  end
  
  def export_camera(p)
    @export_camera=p
    @active_camera=@dlg.get_element_value("active_camera")
    if @export_camera=="true"
        #js=("document.getElementById(\"export_camera\").setAttribute(\"checked\",true);")
        #@dlg.execute_script(js)
        js=("document.getElementById(\"export_camera\").setAttribute(\"value\",\"true\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"active_camera\").setAttribute(\"disabled\",false);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"active_camera_label\").setAttribute(\"disabled\",false);")
        @dlg.execute_script(js)
    else
        #js=("document.getElementById(\"export_camera\").setAttribute(\"checked\",false);")
        #@dlg.execute_script(js)
        js=("document.getElementById(\"export_camera\").setAttribute(\"value\",\"false\");")
        @dlg.execute_script(js)
        js=("document.getElementById(\"active_camera\").setAttribute(\"disabled\",true);")
        @dlg.execute_script(js)
        js=("document.getElementById(\"active_camera_label\").setAttribute(\"disabled\",true);")
        @dlg.execute_script(js)
    end#if
    ###self.populate()
  end#export_camera
  
  def set_camera()
    @active_camera=@dlg.get_element_value("active_camera")
  end#set_camera
  
  def lens_aperture_radius(p)
    @lens_aperture_radius=p
    @lens_aperture_radius_value=@dlg.get_element_value("lens_aperture_radius_value")
    if @lens_aperture_radius=="true"
      #js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"checked\",true);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius_value\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      #js=("document.getElementById(\"horiz_slider_lens\").setAttribute(\"disabled\",false);")
      #@dlg.execute_script(js)
    else
      #js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"checked\",false);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"lens_aperture_radius_value\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      #js=("document.getElementById(\"horiz_slider_lens\").setAttribute(\"disabled\",true);")
      #@dlg.execute_script(js)
    end#if
    ###self.populate()
  end#lens_aperture_radius
  
  def focal_depth(p)
    @focal_depth=p
    @focal_depth_value=@dlg.get_element_value("focal_depth_value")
    if @focal_depth=="true"
      #js=("document.getElementById(\"focal_depth\").setAttribute(\"checked\",true);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth_value\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      #js=("document.getElementById(\"horiz_slider_focal\").setAttribute(\"disabled\",false);")
      #@dlg.execute_script(js)
    else
      #js=("document.getElementById(\"focal_depth\").setAttribute(\"checked\",false);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"focal_depth_value\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      #js=("document.getElementById(\"horiz_slider_focal\").setAttribute(\"disabled\",true);")
      #@dlg.execute_script(js)
    end#if
    ###self.populate()
  end#lens_aperture_radius
  
  def motion_blur(p)
    @motion_blur=p
    @motion_blur_value=@dlg.get_element_value("motion_blur_value")
    if @motion_blur=="true"
      #js=("document.getElementById(\"motion_blur\").setAttribute(\"checked\",true);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"motion_blur\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"motion_blur_value\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      #js=("document.getElementById(\"motion_blur\").setAttribute(\"checked\",false);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"motion_blur\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"motion_blur_value\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    ###self.populate()
  end#lens_aperture_radius

  def export_sun_direction(p)
    @export_sun_direction=p
    @light_source=@dlg.get_element_value("light_source")
    if @export_sun_direction=="true"
      #js=("document.getElementById(\"export_sun_direction\").setAttribute(\"checked\",true);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"export_sun_direction\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source_label\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else
      #js=("document.getElementById(\"export_sun_direction\").setAttribute(\"checked\",false);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"export_sun_direction\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source_label\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"light_source\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
    end#if
    ###self.populate()
  end#export_sun_direction
  
  def gpu_device0(p)
    @gpu_device0=p
    if @gpu_device0=="true"
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
  end
  def gpu_device1(p)
    @gpu_device1=p
    if @gpu_device1=="true"
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
  end
  def gpu_device2(p)
    @gpu_device2=p
    if @gpu_device2=="true"
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
  end
  def gpu_device3(p)
    @gpu_device3=p
    if @gpu_device3=="true"
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
    end#if
  end
  def gpu_devices(p)
    @gpu_devices=p
    if @gpu_devices=="true"
      #js=("document.getElementById(\"gpu_devices\").setAttribute(\"checked\",true);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"checked\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"true\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu0\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu1\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu2\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu3\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
      @gpu_device0="true"
      @gpu_device1="false"
      @gpu_device2="false"
      @gpu_device3="false"
    else
      #js=("document.getElementById(\"gpu_devices\").setAttribute(\"checked\",false);")
      #@dlg.execute_script(js)
      js=("document.getElementById(\"gpu_devices\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device0\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device1\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device2\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"checked\",false);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"value\",\"false\");")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu_device3\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu0\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu1\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu2\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      js=("document.getElementById(\"gpu3\").setAttribute(\"disabled\",true);")
      @dlg.execute_script(js)
      @gpu_device0="false"
      @gpu_device1="false"
      @gpu_device2="false"
      @gpu_device3="false"
    end#if
    ###self.populate()
  end#gpu_devices
  
  def export(anim=false)
    Sketchup.set_status_text("Octane Render: Exporting OBJ & MTL Files...")
    self.getIDvalues()
    self.setIDvalues()### set variables to these values too...
    ### check for validity
    if @project_path=="" or not File.exist?(@project_path)
      UI.messagebox("Octane Render:\nProject Path is not valid.")
      return nil
    end#if
    if @project_name=="" or @project_name=~/ /
      UI.messagebox("Octane Render:\nProject Name is not valid.")
      return nil
    end#if
    ###
    self.run_exporter(anim)
    ###
  end#export
  
  def render()
    self.export()
    ###
	Sketchup.set_status_text("Octane Render: Render...")
    ### make ocs if not there
    prp=@project_path.tr("/","\\")
    prn=@project_name
    ocs=prp+"\\"+prn+".ocs" ###
    obj=prp+"\\"+prn+".obj" ###
    obn=prn+".obj" ###
    ### set variables for command-line
    cline=""
    cline=cline+"@echo off\n" if @pc
    cline=cline+"title Render Cmd\n"
    ###
    orb=@octane_render_binary
    orb=orb+"/Contents/MacOS/octane" if not @pc
    cline=cline+"@" if @pc
    cline=cline+"\""+orb+"\""

    prp=@project_path.tr("/","\\")
    prn=@project_name
    ocs=prp+"\\"+prn+".ocs"
    ona=@obj_name
    ofi=@obj_filepath.tr("/","\\")
    ###
    ### add in 'new' if not exists
    if not File.exist?(ocs)
      cline=cline+" -n \""+ocs+"\""
      cline=cline+" -l \""+ofi+"\""
    end#if
    ###
    ###cline=cline+" -s 4096 "### so continues to render to very high till stopped
    cline=cline+" -m \""+ona+"\""
    cline=cline+" -r \""+ofi+"\"" if File.exist?(ocs)
    ###
    if @resolution=="true"
      wi=@width
      he=@height
      cline=cline+" --film-width " +wi.to_s
      cline=cline+" --film-height "+he.to_s
    else
      wi=nil
      he=nil
    end#if
    ### active camera
  if @export_camera=="true"
    cams=@cameras_array
    acc=@model.active_view.camera
    pages=@model.pages
    case @active_camera
      when "from <Current View>"
        acc=@model.active_view.camera
      when "from <Current Scene>"
        acc=@model.pages.selected_page.camera
      else
        pages.each{|p|acc=p.camera if p.name==@active_camera}
    end#case    
    posa=acc.eye.to_a
    pos=[0,0,0]
    pos.x=posa.x.to_m.to_f
    pos.y=posa.z.to_m.to_f      ###
    pos.z=posa.y.to_m.to_f * -1 ###
    targeta=acc.target.to_a
    target=[0,0,0]
    target.x=targeta.x.to_m.to_f
    target.y=targeta.z.to_m.to_f        ###
    target.z=targeta.y.to_m.to_f * -1   ###
    upa=acc.up.normalize.to_a
    up=[0,0,0]
    up.x=upa.x.to_f
    up.y=upa.z.to_f        ###
    up.z=upa.y.to_f * -1   ###
    ###
    cline=cline+" --cam-pos-x "+pos.x.to_s
    cline=cline+" --cam-pos-y "+pos.y.to_s
    cline=cline+" --cam-pos-z "+pos.z.to_s
    ###
    cline=cline+" --cam-target-x "+target.x.to_s
    cline=cline+" --cam-target-y "+target.y.to_s
    cline=cline+" --cam-target-z "+target.z.to_s
    ###
    cline=cline+" --cam-up-x "+up.x.to_s
    cline=cline+" --cam-up-y "+up.y.to_s
    cline=cline+" --cam-up-z "+up.z.to_s
    ###
    fol=acc.focal_length
    fovV=acc.fov
    wid=@width.to_f
    hei=@height.to_f
    if acc.image_width != 0
      wid=acc.image_width
      if acc.aspect_ratio != 0
        aro=acc.aspect_ratio
      else
        aro=wid/hei
      end#if
      hei=wid/aro
    end#if
    h=2*fol*Math::tan(fovV.degrees/2)
    w=h*wid/hei
    fov=(2*Math::atan(w/(2*fol))).radians
    cline=cline+" --cam-fov "+fov.to_s
    ###
  end#if export_camera
    ###
    if @lens_aperture_radius=="true"
      apr=@lens_aperture_radius_value
      cline=cline+" --cam-aperture "+apr.to_s
    else
      apr=nil
    end#if
    if @focal_depth=="true"
      foc=@focal_depth_value
      cline=cline+" --cam-focaldepth "+foc.to_s
    end#if
    ###
    if @motion_blur=="true"
      mob=@motion_blur_value
    else
      mob=""
    end#if
    mbc=nil
    case mob
      when "Next"
        if @active_camera=="from <Current View>"
          mbc=nil
        elsif @active_camera=="from <Current Scene>"
          pages=@model.pages.to_a
          cac=@model.pages.selected_page
          cur=pages.index(cac)
          nxt=cur+1
          mbc=pages[nxt]
          if mbc
            mbc=mbc.camera
          else
            mbc=pages[0].camera
          end#if
        else
          pages=@model.pages.to_a
          cac=pages[0]
          pages.each{|p|cac=p if p.name==@active_camera}
          cur=pages.index(cac)
          nxt=cur+1
          mbc=pages[nxt]
          if mbc
            mbc=mbc.camera
          else
            mbc=pages[0].camera
          end#if
        end#if
      when "Previous"
        if @active_camera=="from <Current View>"
          mbc=nil
        elsif @active_camera=="from <Current Scene>"
          pages=@model.pages.to_a
          cac=@model.pages.selected_page
          cur=pages.index(cac)
          nxt=cur-1
          mbc=pages[nxt]
          if mbc
            mbc=mbc.camera
          else
            mbc=pages[-1].camera
          end#if
        else
          pages=@model.pages.to_a
          cac=pages[0]
          pages.each{|p|cac=p if p.name==@active_camera}
          cur=pages.index(cac)
          nxt=cur-1
          mbc=pages[nxt]
          if mbc
            mbc=mbc.camera
          else
            mbc=pages[-1].camera
          end#if
        end#if
      else
        mbc=nil
    end#case
    if mbc
      mposa=mbc.eye.to_a
      mpos=mposa
      mpos.x=mposa.x.to_m.to_f
      mpos.y=mposa.z.to_m.to_f
      mpos.z=mposa.y.to_m.to_f * -1
      mtargeta=mbc.target.to_a
      mtarget=mtargeta
      mtarget.x=mtargeta.x.to_m.to_f
      mtarget.y=mtargeta.z.to_m.to_f
      mtarget.z=mtargeta.y.to_m.to_f * -1
      mupa=mbc.up.normalize.to_a
      mup=mupa
      mup.x=mupa.x.to_f
      mup.y=mupa.z.to_f
      mup.z=mupa.y.to_f * -1
      ###
      cline=cline+" --cam-motion-pos-x "+mpos.x.to_s
      cline=cline+" --cam-motion-pos-y "+mpos.y.to_s
      cline=cline+" --cam-motion-pos-z "+mpos.z.to_s
      ###
      cline=cline+" --cam-motion-target-x "+mtarget.x.to_s
      cline=cline+" --cam-motion-target-y "+mtarget.y.to_s
      cline=cline+" --cam-motion-target-z "+mtarget.z.to_s
      ###
      cline=cline+" --cam-motion-up-x "+mup.x.to_s
      cline=cline+" --cam-motion-up-y "+mup.y.to_s
      cline=cline+" --cam-motion-up-z "+mup.z.to_s
      ###
    end#if
    ### sun etc ?
    if @export_sun_direction=="true"
      pages=@model.pages.to_a
      case @light_source
        when "Sun from <Current View>"
          sunv=@model.shadow_info["SunDirection"]
        when "Sun from <Current Scene>"
          sunv=@model.pages.selected_page.shadow_info["SunDirection"]
        else
          spa=nil
          pages.each{|p|spa=p if p.name==@light_source}
          sunv=spa.shadow_info["SunDirection"]
      end#case
      suna=sunv.normalize.to_a
      sun=[0,0,0]
      sun.x=suna.x.to_f
      sun.y=suna.z.to_f
      sun.z=suna.y.to_f * -1
      cline=cline+" --daylight-sundir-x "+sun.x.to_s
      cline=cline+" --daylight-sundir-y "+sun.y.to_s
      cline=cline+" --daylight-sundir-z "+sun.z.to_s
    end#if
    ### GPUs ?
    if @gpu_devices=="true"
      if @gpu_device0=="true"
        cline=cline+" -g 0"
      end#if
      if @gpu_device1=="true"
        cline=cline+" -g 1"
      end#if
      if @gpu_device2=="true"
        cline=cline+" -g 2"
      end#if
      if @gpu_device3=="true"
        cline=cline+" -g 3"
      end#if
    end#if
    ###
    if not File.exist?(ocs)
      cline=cline+"\n"
    else
      cline=cline+" \""+ocs+"\"\n"
    end#if
    ###
    cline=cline+"@exit\n" if @pc
    ###
    if @pc
      ### make cmd file
      cmd_path=@project_path.tr("\\","/")+"/octane.cmd"
      cmd=File.new(cmd_path, "w")
      cmd.puts cline
      cmd.close
      ### make start.cmd
      start_path=@project_path.tr("\\","/")+"/start.cmd"
      cmd=File.new(start_path, "w")
      cmd.puts "cd \""+@project_path.tr("/","\\")+"\"\nstart /MIN octane.cmd\n"
      cmd.close
      ### run cmd file minimized
      UI.openURL(start_path)
      sleep(2);File.delete(start_path)
      #File.delete(cmd_path)###delete cmd file afterwards: disabled for debug.
    else ### it's a Mac
      cline="#!/bin/bash\n"+cline ### makes it execute in a shell ???
      ### ???
      cline.tr!("\\","/")### force unix friendly separators
      cline=cline.gsub(/\"/){'\\"'}### escape " as \" IS NEEDED - SO DO ALL
      ### NOW we must un-escape all \"app\" to "app" ...
      cline=cline.gsub(/\\\"#{orb.tr("\\","/")}\\\"/,"\"#{orb.tr("\\","/")}\"")
      cline=cline.gsub(/^@/){''}### removing leading @'s IF ANY ???
      ### change 'title' to suit Mac
      cline=cline.sub(/^title Render Cmd/){'echo -ne "\033]0;Render Cmd\007"'}###########
      ### fix echo off to suit Mac
      cline=cline.sub(/^echo off\n/,'')
      ###
      cmd_path=@project_path.tr("\\","/")+"/octane.command"
      cmd=File.new(cmd_path, "w")
      cmd.puts cline
      cmd.close
      File.chmod(0777, cmd_path)
      ### run cmd file
      UI.openURL("file:///"+cmd_path)
      #sleep(2); File.delete(cmd_path)
      ###delete cmd file afterwards: disabled for debug.
      ###
    end#if
    ###
  end#render
  
  def select_image_output()
    Sketchup.set_status_text("Octane Render: Select Image Output Folder...")
    ### browse for folder
    @image_output=@dlg.get_element_value("image_output")
    ###
    if File.exist?(@project_path)
      self.startfb(@project_path, "image")
    else
      self.startfb(Dir.pwd, "image")
    end#if
    ###
  end#select_image_output
  
  def update_image()
    image_output = @octane_render_folder_browser_result
    #image_output=UI.openpanel("Choose the 'Image Output' File [.PNG] or Any File to Select its Folder...")
    Sketchup.set_status_text("Octane Render:")
    if not image_output
      return nil
    end#if
    image_out=File.join(image_output, @image_name)
    image_out.tr!("/","\\")if @pc
    @image_output=image_out
    @model.set_attribute("Octane", "image_output", @image_output)
    ###
    image_out=@image_output.gsub(/\\/){'\\\\'} if @pc
    js=("document.getElementById(\"image_output\").setAttribute(\"value\",\""+image_out+"\");")
    @dlg.execute_script(js)
    ###self.populate()
  end#update_image
  
  def update_pixs()
    pixsa=@dlg.get_element_value("pixel_samples")
    if pixsa=~/Custom/
      pixs=@pixs
    else
      pixs=pixsa.split("(")[1].to_i.to_s
    end#if    
    js=("document.getElementById(\"pixs\").setAttribute(\"value\",\""+pixs+"\");")
    @dlg.execute_script(js)
    @pixs=@dlg.get_element_value("pixs")
  end#update_pixs
  
  def update_pixs_txt()
    pixs=@dlg.get_element_value("pixs")
    pix=pixs.to_i.to_s
    ### update list too
    tester="Custom"
    pixel_samples_array=@pixel_samples_array
    (pixel_samples_array-[tester]).each{|txt|
      if pix == txt.split("(")[1].to_i.to_s
        tester=txt
        break
      end#if
    }
    pixel_samples_array.each_with_index do |p,i|
    js="document.getElementById(\"pixel_samples\")[#{i}] = new Option('#{p}','#{p}'"
	js+=",true,true" if p==tester ### SELECTED pixel_samples
	js+=");"
	@dlg.execute_script(js)
    @pixel_samples=@dlg.get_element_value("pixel_samples")
    end#if
    js=("document.getElementById(\"pixs\").setAttribute(\"value\",\""+pix+"\");")
    @dlg.execute_script(js)
    @pixs=@dlg.get_element_value("pixs")
  end#update_pixs_txt
  
  def update_start()
    if not @start_frame or @start_frame=="" or not @scenes.include?(@start_frame)
      @start_frame=@scenes[0]
    else
      @start_frame=@dlg.get_element_value("start_frame")
    end#if
    start_frame_array=@scenes[0..-2] ### not the last one
	start_frame_array.each_with_index do |p,i|
		js="document.getElementById(\"start_frame\")[#{i}] = new Option('#{p}','#{p}'"
        js+=",true,true" if @start_frame==p ### SELECTED start_frame
		js+=");"
		@dlg.execute_script(js)
	end#do
    @start_frame=@dlg.get_element_value("start_frame")
  end#update_start
  
  def update_end()
    if not @end_frame or @end_frame=="" or not @scenes.include?(@end_frame)
      @end_frame=@scenes[0]
    else
      @end_frame=@dlg.get_element_value("end_frame")
    end#if
    end_frame_array=@scenes[1..-1] ### not the first one
	end_frame_array.each_with_index do |p,i|
		js="document.getElementById(\"end_frame\")[#{i}] = new Option('#{p}','#{p}'"
        js+=",true,true" if @end_frame==p ### SELECTED end_frame
		js+=");"
		@dlg.execute_script(js)
	end#do
    @end_frame=@dlg.get_element_value("end_frame")
  end#update_end
  
  def update_step()
    if not @step or @step==""
      @step="1"
    else
      begin
        @step=@dlg.get_element_value("step")
      rescue
        @step="1"
      end
    end#if
    ### calculate step list
    step_array=[]
    if @scenes[1]
      @scenes[1..-1].length.times{|i|step_array << (i+1).to_s}
    end#if
    if not step_array.include?(@step) or not step_array[0]
      @step="1"
    end#if
    step_array.each_with_index do |p,i|
	  js="document.getElementById(\"step\")[#{i}] = new Option('#{p}','#{p}'"
      js+=",true,true" if @step==p ### SELECTED step
	  js+=");"
	  @dlg.execute_script(js)
	end#do
    @step=@dlg.get_element_value("step")
  end#update_step
  
  def get_scenes()### only 'anim' scenes
    @all_pages=@model.pages.to_a
    @scenes=[]; @all_pages.each{|p|@scenes<< p.name if p.name==p.label}
  end#get_scenes
  
  def render_animation()
    return nil if not @start_frame or @start_frame=="" or not @scenes.flatten.include?(@start_frame)
    self.set_button(true)
    js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",true);")
    @dlg.execute_script(js)
    ###
    anim=true
    self.export(anim) ### also gets IDs
    Sketchup.set_status_text("Octane Render: To Abort - Close the Separate 'Animation Cmd' Window...")
    ###
    startf=@start_frame
    endf=@end_frame
    step=@step.to_i
    ###
    opu=@image_output
    opudiry=File.dirname(opu)
    opuextn=File.extname(opu)
    opuname=File.basename(opu, opuextn)
    opu=File.join(opudiry, opuname)
    opu.tr!("/","\\")
    ###
    pages=@model.pages
    cameras=[]; pages.each{|p|cameras << p.camera}
    ###
    scenes=@scenes
    s_indx=scenes.index(startf)
    e_indx=scenes.index(endf)
    anim_scenes=scenes[s_indx..e_indx]
    ### adjust array for step
    step_scenes=[]
    0.step(anim_scenes.length-1, step){|i|step_scenes << anim_scenes[i]}
    anim_scenes=step_scenes
    ### 
    ### make we FIRDT frame - making ocs if not exists
    scene_name=anim_scenes[0]
    scene=nil
    @model.pages.each{|p|
      if p.name==scene_name
        scene=p
        break
      end#if
    }
    return nil if not scene
    ###
    ### set frame >>>>>>>>>>>>>>>>>>>
    ### set variables for command-line
    cline=""
    cline=cline+"@echo off\n" if @pc
    cline=cline+"title Animation Cmd\n"
    ###
    orb=@octane_render_binary
    orb=orb+"/Contents/MacOS/octane" if not @pc
    cline=cline+"@" if @pc
    cline=cline+"\""+orb+"\" -e -q"
    ###
    prp=@project_path.tr("/","\\")
    prn=@project_name
    ocs=prp+"\\"+prn+".ocs"
    oob=prn+".obj" ### ORIGINAL BASE OBJ###
    obj=prp+"\\"+prn+".obj" ###"_anim.obj" ###
    ona=oob
    ofi=@obj_filepath.tr("/","\\")
    ### add in 'new' if not exists
    if not File.exist?(ocs)
      cline=cline+" -n \""+ocs+"\""
      cline=cline+" -l \""+obj+"\""
    end#if    ###
    sam=@pixs
    cline=cline+" -s "+sam
    cline=cline+" -m \""+ona+"\""
    cline=cline+" -r \""+ofi+"\"" if File.exist?(ocs)
    ###
    ### here we add the opu etc
    opux=opu+opuextn
    ###
    cline=cline+" -o \""+opux+"\""
    ###
    if @resolution=="true"
      wi=@width
      he=@height
      cline=cline+" --film-width " +wi.to_s
      cline=cline+" --film-height "+he.to_s
    else
      wi=nil
      he=nil
    end#if
    ###
    ### ALWAYS export the camera !
  #if @export_camera=="true"
    ### get camera
    acc=scene.camera
    posa=acc.eye.to_a
    pos=[0,0,0]
    pos.x=posa.x.to_m.to_f
    pos.y=posa.z.to_m.to_f
    pos.z=posa.y.to_m.to_f * -1
    targeta=acc.target.to_a
    target=[0,0,]
    target.x=targeta.x.to_m.to_f
    target.y=targeta.z.to_m.to_f
    target.z=targeta.y.to_m.to_f * -1
    upa=acc.up.normalize.to_a
    up=[0,0,0]
    up.x=upa.x.to_f
    up.y=upa.z.to_f
    up.z=upa.y.to_f * -1
    ###
    cline=cline+" --cam-pos-x "+pos.x.to_s
    cline=cline+" --cam-pos-y "+pos.y.to_s
    cline=cline+" --cam-pos-z "+pos.z.to_s
    ###
    cline=cline+" --cam-target-x "+target.x.to_s
    cline=cline+" --cam-target-y "+target.y.to_s
    cline=cline+" --cam-target-z "+target.z.to_s
    ###
    cline=cline+" --cam-up-x "+up.x.to_s
    cline=cline+" --cam-up-y "+up.y.to_s
    cline=cline+" --cam-up-z "+up.z.to_s
    ###
    fol=acc.focal_length
    fovV=acc.fov
    wid=@width.to_f
    hei=@height.to_f
    if acc.image_width != 0
      wid=acc.image_width
      if acc.aspect_ratio != 0
        aro=acc.aspect_ratio
      else
        aro=wid/hei
      end#if
      hei=wid/aro
    end#if
    h=2*fol*Math::tan(fovV.degrees/2)
    w=h*wid/hei
    fov=(2*Math::atan(w/(2*fol))).radians
    cline=cline+" --cam-fov "+fov.to_s
  #end#if export_camera
    ###
    if @lens_aperture_radius=="true"
      apr=@lens_aperture_radius_value
      cline=cline+" --cam-aperture "+apr.to_s
    else
      apr=nil
    end#if
    if @focal_depth=="true"
      foc=@focal_depth_value
      cline=cline+" --cam-focaldepth "+foc.to_s
    end#if
    ###
    if @motion_blur=="true"
      mob=@motion_blur_value
    else
      mob=""
    end#if
    mbc=nil
    case mob
      when "Next"
        mbc=nil
        scene_indx=scenes.index(scene)
        mb_indx=scene_indx+1
        mbc=scenes[mb_indx]
      when "Previous"
        mbc=nil
        scene_indx=scenes.index(scene)
        mb_indx=scene_indx-1
        mbc=scenes[mb_indx]
      else
        mbc=nil
    end#case
    if mbc
      mposa=mbc.eye.to_a
      mpos=[0,0,0]
      mpos.x=mposa.x.to_m.to_f
      mpos.y=mposa.z.to_m.to_f
      mpos.z=mposa.y.to_m.to_f * -1
      mtargeta=mbc.target.to_a
      mtarget=[0,0,0]
      mtarget.x=mtargeta.x.to_m.to_f
      mtarget.y=mtargeta.z.to_m.to_f
      mtarget.z=mtargeta.y.to_m.to_f * -1
      mupa=mbc.up.normalize.to_a
      mup=[0,0,0]
      mup.x=mupa.x.to_f
      mup.y=mupa.z.to_f
      mup.z=mupa.y.to_f * -1
      ###
      cline=cline+" --cam-motion-pos-x "+mpos.x.to_s
      cline=cline+" --cam-motion-pos-y "+mpos.y.to_s
      cline=cline+" --cam-motion-pos-z "+mpos.z.to_s
      ###
      cline=cline+" --cam-motion-target-x "+mtarget.x.to_s
      cline=cline+" --cam-motion-target-y "+mtarget.y.to_s
      cline=cline+" --cam-motion-target-z "+mtarget.z.to_s
      ###
      cline=cline+" --cam-motion-up-x "+mup.x.to_s
      cline=cline+" --cam-motion-up-y "+mup.y.to_s
      cline=cline+" --cam-motion-up-z "+mup.z.to_s
      ###
    end#if
    ### sun etc ?
    if @export_sun_direction=="true"
      sunv=scene.shadow_info["SunDirection"]
      suna=sunv.normalize.to_a
      sun=[0,0,0]
      sun.x=suna.x.to_f
      sun.y=suna.z.to_f
      sun.z=suna.y.to_f * -1
      cline=cline+" --daylight-sundir-x "+sun.x.to_s
      cline=cline+" --daylight-sundir-y "+sun.y.to_s
      cline=cline+" --daylight-sundir-z "+sun.z.to_s
    end#if
    ### GPUs ?
    if @gpu_devices=="true"
      if @gpu_device0=="true"
        cline=cline+" -g 0"
      end#if
      if @gpu_device1=="true"
        cline=cline+" -g 1"
      end#if
      if @gpu_device2=="true"
        cline=cline+" -g 2"
      end#if
      if @gpu_device3=="true"
        cline=cline+" -g 3"
      end#if
    end#if
    if not File.exist?(ocs)
      cline=cline+"\n"
    else
      cline=cline+" \""+ocs+"\"\n"
    end#if
    ###
    opu.next! ### increments the img00001 > img00002 etc
    
    ### make rest of scenes
  anim_scenes[1..-1].each{|scene_name|
    scene=nil
    @model.pages.each{|p|
      if p.name==scene_name
        scene=p
        break
      end#if
    }
    next if not scene
    ### set variables for command-line
    ###
    orb=@octane_render_binary
    orb=orb+"/Contents/MacOS/octane" if not @pc
    cline=cline+"@" if @pc
    cline=cline+"\""+orb+"\" -e -q"
    ###
    ### here we add the opu etc
    opux=opu+opuextn
    ###
    cline=cline+" -o \""+opux+"\""
    ###
    sam=@pixs
    cline=cline+" -s "+sam
    ###
    ona=oob ###@obj_name
    cline=cline+" -m \""+ona+"\"" ### OOB NOT @obj_name
    ###
    ofi=@obj_filepath.tr("/","\\")
    #cline=cline+" -l \""+ofi+"\"" ### no need to link in anim obj ?
    cline=cline+" -r \""+ofi+"\"" if File.exist?(ocs)
    ###
    if @resolution=="true"
      wi=@width
      he=@height
      cline=cline+" --film-width " +wi.to_s
      cline=cline+" --film-height "+he.to_s
    else
      wi=nil
      he=nil
    end#if
    ###
    ### ALWAYS export the camera !
  #if @export_camera=="true"
    ### get camera
    acc=scene.camera
    posa=acc.eye.to_a
    pos=[0,0,0]
    pos.x=posa.x.to_m.to_f
    pos.y=posa.z.to_m.to_f
    pos.z=posa.y.to_m.to_f * -1
    targeta=acc.target.to_a
    target=[0,0,]
    target.x=targeta.x.to_m.to_f
    target.y=targeta.z.to_m.to_f
    target.z=targeta.y.to_m.to_f * -1
    upa=acc.up.normalize.to_a
    up=[0,0,0]
    up.x=upa.x.to_f
    up.y=upa.z.to_f
    up.z=upa.y.to_f * -1
    ###
    cline=cline+" --cam-pos-x "+pos.x.to_s
    cline=cline+" --cam-pos-y "+pos.y.to_s
    cline=cline+" --cam-pos-z "+pos.z.to_s
    ###
    cline=cline+" --cam-target-x "+target.x.to_s
    cline=cline+" --cam-target-y "+target.y.to_s
    cline=cline+" --cam-target-z "+target.z.to_s
    ###
    cline=cline+" --cam-up-x "+up.x.to_s
    cline=cline+" --cam-up-y "+up.y.to_s
    cline=cline+" --cam-up-z "+up.z.to_s
    ###
    fol=acc.focal_length
    fovV=acc.fov
    wid=@width.to_f
    hei=@height.to_f
    if acc.image_width != 0
      wid=acc.image_width
      if acc.aspect_ratio != 0
        aro=acc.aspect_ratio
      else
        aro=wid/hei
      end#if
      hei=wid/aro
    end#if
    h=2*fol*Math::tan(fovV.degrees/2)
    w=h*wid/hei
    fov=(2*Math::atan(w/(2*fol))).radians
    cline=cline+" --cam-fov "+fov.to_s
  #end#if export_camera
    ###
    if @lens_aperture_radius=="true"
      apr=@lens_aperture_radius_value
      cline=cline+" --cam-aperture "+apr.to_s
    else
      apr=nil
    end#if
    if @focal_depth=="true"
      foc=@focal_depth_value
      cline=cline+" --cam-focaldepth "+foc.to_s
    end#if
    ###
    if @motion_blur=="true"
      mob=@motion_blur_value
    else
      mob=""
    end#if
    mbc=nil
    case mob
      when "Next"
        mbc=nil
        scene_indx=scenes.index(scene)
        mb_indx=scene_indx+1
        mbc=scenes[mb_indx]
      when "Previous"
        mbc=nil
        scene_indx=scenes.index(scene)
        mb_indx=scene_indx-1
        mbc=scenes[mb_indx]
      else
        mbc=nil
    end#case
    if mbc
      mposa=mbc.eye.to_a
      mpos=[0,0,0]
      mpos.x=mposa.x.to_m.to_f
      mpos.y=mposa.z.to_m.to_f
      mpos.z=mposa.y.to_m.to_f * -1
      mtargeta=mbc.target.to_a
      mtarget=[0,0,0]
      mtarget.x=mtargeta.x.to_m.to_f
      mtarget.y=mtargeta.z.to_m.to_f
      mtarget.z=mtargeta.y.to_m.to_f * -1
      mupa=mbc.up.normalize.to_a
      mup=[0,0,0]
      mup.x=mupa.x.to_f
      mup.y=mupa.z.to_f
      mup.z=mupa.y.to_f * -1
      ###
      cline=cline+" --cam-motion-pos-x "+mpos.x.to_s
      cline=cline+" --cam-motion-pos-y "+mpos.y.to_s
      cline=cline+" --cam-motion-pos-z "+mpos.z.to_s
      ###
      cline=cline+" --cam-motion-target-x "+mtarget.x.to_s
      cline=cline+" --cam-motion-target-y "+mtarget.y.to_s
      cline=cline+" --cam-motion-target-z "+mtarget.z.to_s
      ###
      cline=cline+" --cam-motion-up-x "+mup.x.to_s
      cline=cline+" --cam-motion-up-y "+mup.y.to_s
      cline=cline+" --cam-motion-up-z "+mup.z.to_s
      ###
    end#if
    ### sun etc ?
    if @export_sun_direction=="true"
      sunv=scene.shadow_info["SunDirection"]
      suna=sunv.normalize.to_a
      sun=[0,0,0]
      sun.x=suna.x.to_f
      sun.y=suna.z.to_f
      sun.z=suna.y.to_f * -1
      cline=cline+" --daylight-sundir-x "+sun.x.to_s
      cline=cline+" --daylight-sundir-y "+sun.y.to_s
      cline=cline+" --daylight-sundir-z "+sun.z.to_s
    end#if
    ### GPUs ?
    if @gpu_devices=="true"
      if @gpu_device0=="true"
        cline=cline+" -g 0"
      end#if
      if @gpu_device1=="true"
        cline=cline+" -g 1"
      end#if
      if @gpu_device2=="true"
        cline=cline+" -g 2"
      end#if
      if @gpu_device3=="true"
        cline=cline+" -g 3"
      end#if
    end#if
    cline=cline+" \""+ocs+"\"\n"
    ###
    opu.next! ### increments the img00001 > img00002 etc
    ###
  }#anim_scenes
    ###
    cline=cline+"@exit\n"
    ###
    ###
    if @pc
      ### make cmd file
      cmd_path=@project_path.tr("\\","/")+"/octane_anim.cmd"
      cmd=File.new(cmd_path, "w")
      cmd.puts cline
      cmd.close
      ### make start_anim.cmd
      start_path=@project_path.tr("\\","/")+"/start_anim.cmd"
      cmd=File.new(start_path, "w")
      cmd.puts "cd \""+@project_path.tr("/","\\")+"\"\nstart /MIN octane_anim.cmd\n"
      cmd.close
      ### run cmd file minimized
      UI.openURL(start_path)
      sleep(2);File.delete(start_path)
      #File.delete(cmd_path)###delete cmd file afterwards: disabled for debug.
    else ### it's a Mac
      cline="#!/bin/bash\n"+cline ### makes it execute in a shell ???
      ### ???
      cline.tr!("\\","/")### force unix friendly separators
      cline=cline.gsub(/\"/){'\\"'}### escape " as \" IS NEEDED - SO DO ALL
      ### NOW we must un-escape all \"app\" to "app" ...
      cline=cline.gsub(/\\\"#{orb.tr("\\","/")}\\\"/,"\"#{orb.tr("\\","/")}\"")
      cline=cline.gsub(/^@/){''}### removing leading @'s IF ANY ???
      ### change 'title' to suit Mac
      cline=cline.sub(/^title Animation Cmd/){'echo -ne "\033]0;Animation Cmd\007"'}###########
      ### fix echo off to suit Mac
      cline=cline.sub(/^echo off\n/,'')
      ###
      cmd_path="file:///"+@project_path.tr("\\","/")+"/octane_anim.command"
      cmd=File.new(cmd_path, "w")
      cmd.puts cline
      cmd.close
      File.chmod(0777, cmd_path)
      ### run cmd file
      UI.openURL("file:///"+cmd_path)
      #sleep(2); File.delete(cmd_path)
      ###delete cmd file afterwards: disabled for debug.
      ###
    end#if
    ### we must wait for frames to be made... or cancel HOW?
    ### = close cmd/command window = end
    if @pc
      sleep(2)
      procs=self.processes_pc()
      while procs.include?("cmd.exe")
        sleep(1)
        procs=self.processes_pc()
      end#wait till cmd closed
      self.set_button()
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    else ### Mac
      sleep(2)
      procs=self.processes_mac()
      while procs.include?("command")
        sleep(1)
        procs=self.processes_mac()
      end#wait till cmd closed
      self.set_button()
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"disabled\",false);")
      @dlg.execute_script(js)
    end#if  
    ###
    Sketchup.set_status_text("Octane Render:")
    ###
  end#render_animation
  
  def processes_pc()
    return if not @pc
    require 'win32ole.so'
    procs=WIN32OLE.connect("winmgmts:\\\\.")
    ps=[]
    procs.InstancesOf("win32_process").each{|p|ps << p.name.to_s.downcase}
    return ps
  end#processes_pc
  
  def processes_mac()
    #puts "Mac process list."
    return [] ### to add code here
  end#processes_mac
  
  def set_button(ren=false)
    if ren
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"value\",\"Rendering Animation, Please Wait...\");")
      @dlg.execute_script(js)
    else
      js=("document.getElementById(\"render_animation_button\").setAttribute(\"value\",\"Render Animation\");")
      @dlg.execute_script(js)
    end#if
  end#set_button
  
  def is_cancelled?()
    
  end#is_cancelled?
  
  def help()
    help="OctaneHelp.pdf"
    help_path=File.join(File.dirname(__FILE__), help)
    if File.exist?(help_path)
      UI.openURL(help_path) if @pc
      UI.openURL("file:///"+help_path) if not @pc
    else
      UI.messagebox("Octane Render:\nHelp file not found\n["+help_path+"]")
    end#if
  end#help
  
  def getIDvalues()
    @values={} ### hash to hold id values - ALL as strings
    @@idset.each{|id|@values[id]=@dlg.get_element_value(id)}
  end#getIDvalues
  
  def setIDvalues()
    ###
    @octane_render_binary=@values["octane_render_binary"]
	@project_path=@values["project_path"]
	@project_name=@values["project_name"]
	@native_unit_size=@values["native_unit_size"]
    
	@resolution=@values["resolution"]
    @width=@values["width"]
    @height=@values["height"]
    @percentage=@values["percentage"]
    
    @export_camera=@values["export_camera"]
    @active_camera=@values["active_camera"]
    @lens_aperture_radius=@values["lens_aperture_radius"]
    @lens_aperture_radius_value=@values["lens_aperture_radius_value"]
    @focal_depth=@values["focal_depth"]
    @focal_depth_value=@values["focal_depth_value"]
    @motion_blur=@values["motion_blur"]
    @motion_blur_value=@values["motion_blur_value"]
    
    @export_sun_direction=@values["export_sun_direction"]
    @light_source=@values["light_source"]
    
    @gpu_devices=@values["gpu_devices"]
    @gpu_device0=@values["gpu_device0"]
    @gpu_device1=@values["gpu_device1"]
    @gpu_device2=@values["gpu_device2"]
    @gpu_device3=@values["gpu_device3"]

    @image_output=@values["image_output"]
    @start_frame=@values["start_frame"]
    @end_frame=@values["end_frame"]
    @step=@values["step"]
    @pixel_samples=@values["pixel_samples"]
    @pixs=@values["pixs"]
    ###
  end#setIDvalues
  
  def saveIDvalues()
    #puts 'saveIDvalues TO DO'
    ### save all settings to SUp or SKP
    Sketchup.write_default("Octane","octane_render_binary", @octane_render_binary.gsub(/\\/){'\\\\'})
    #
    @model.set_attribute("Octane", "project_path", @project_path)
    @model.set_attribute("Octane", "project_name", @project_name)
	#@native_unit_size dynamic
    
    @model.set_attribute("Octane", "resolution", @resolution)
    @model.set_attribute("Octane", "width", @width)
    @model.set_attribute("Octane", "height", @height)
    @model.set_attribute("Octane", "percentage", @percentage)
    
    @model.set_attribute("Octane", "export_camera", @export_camera)
    @model.set_attribute("Octane", "active_camera", @active_camera)
    @model.set_attribute("Octane", "lens_aperture_radius", @lens_aperture_radius)
    @model.set_attribute("Octane", "lens_aperture_radius_value", @lens_aperture_radius_value)
    @model.set_attribute("Octane", "focal_depth", @focal_depth)
    @model.set_attribute("Octane", "focal_depth_value", @focal_depth_value)
    @model.set_attribute("Octane", "motion_blur", @motion_blur)
    @model.set_attribute("Octane", "motion_blur_value", @motion_blur_value)
    
    @model.set_attribute("Octane", "export_sun_direction", @export_sun_direction)
    @model.set_attribute("Octane", "light_source", @light_source)
    
    @model.set_attribute("Octane", "gpu_devices", @gpu_devices)
    @model.set_attribute("Octane", "gpu_device0", @gpu_device0)
    @model.set_attribute("Octane", "gpu_device1", @gpu_device1)
    @model.set_attribute("Octane", "gpu_device2", @gpu_device2)
    @model.set_attribute("Octane", "gpu_device3", @gpu_device3)
    
    @model.set_attribute("Octane", "image_output", @image_output)

    @model.set_attribute("Octane", "start_frame", @start_frame)
    @model.set_attribute("Octane", "end_frame", @end_frame)
    @model.set_attribute("Octane", "step", @step)
    @model.set_attribute("Octane", "pixel_samples", @pixel_samples)
    @model.set_attribute("Octane", "pixs", @pixs)
    ###
  end#saveIDvalues
  
############## obj exporter part #############################
  
    def run_exporter(anim=false)
        self.settings(anim)
        self.do_export()
	end
	
	def settings(anim=false)
		@obj_="true"
        @obj_name=@project_name
        @obj_name=@obj_name+"_anim" if anim
        @obj_name=@obj_name+".obj"
        @obj_filepath=@project_path+"/"+@obj_name
        @mtllib=@project_name
        @mtllib=@mtllib+"_anim" if anim
        @mtllib=@mtllib+".mtl"
        @mtl_file=@project_path+"/"+@mtllib
		@textures_name=@project_name+"_Textures"
        @textures_name=@textures_name+"_anim" if anim
		@v_counter=0
		@obj_list=[]
		@textures_path=""
		@used_materials=[]
	end
    
	def do_export()
        Sketchup.set_status_text("Octane Render: Exporting OBJ & MTL Files...")
		starttime=Time.now.to_f
	    @title=Sketchup.active_model.title
	    @title="Untitled" if @title==""
	    Dir.mkdir(@project_path) if not File.exist?(@project_path)
        ###
        self.export_start()
        ###
		endtime=(((Time.now.to_f - starttime)*10000).to_i/10000.0).to_f.to_s
		Sketchup.set_status_text("Octane Render: OBJ & MTL Files Completed in #{endtime} seconds")
	end
    
    def export_start()
		@obj_file=File.new(@obj_filepath, "w")
        @obj_file.puts "# Alias Wavefront OBJ File Exported from SketchUp by 'Octane'"
        @obj_file.puts "# (c) 2010 TIG & Refractive Software"
        @obj_file.puts "# Units = meters"
        @obj_file.puts ""
		@obj_file.puts "mtllib #{@mtllib}"
        @obj_file.puts ""
		Sketchup.set_status_text("Octane Render: Making OBJ File...")
		self.export_obj()
		@obj_file.close if @obj_file
        Sketchup.set_status_text("Octane Render: Exporting Textures...")
		self.export_textures()
        Sketchup.set_status_text("Octane Render: Making MTL File...")
		self.export_mtl_material()
	end

	def export_obj()
        @img_mats=[]
		title=@title
		ents=Sketchup.active_model.entities.to_a
		objname=title+"_Main"
		Sketchup.set_status_text("Octane Render: Making Meshes...")
        faces=ents.find_all{|e|e.class==Sketchup::Face}
	    if faces[0]
			@obj_list << [objname, nil, "Default_Material"] 
		    self.export_entities(faces, objname)
		end#if
		Sketchup.set_status_text("Octane Render: Meshes Completed.")
		tr=Geom::Transformation.axes( (Geom::Point3d.new 0,0,0),(Geom::Vector3d.new(1,0,0)),(Geom::Vector3d.new(0,1,0)),(Geom::Vector3d.new(0,0,1)) )
        ###
	    ents.find_all{|e|e.class==Sketchup::Group}.each{|gp| self.export_group(gp, title, tr) }
	    ents.find_all{|e|e.class==Sketchup::ComponentInstance}.each{|ci| self.export_component_instance(ci, title, tr) }
        ents.find_all{|e|e.class==Sketchup::Image}.each{|ci| self.export_image(ci, title, tr) }
        ###
	end

	def export_group(gp, title="", tr=Geom::Transformation.new, mat=nil)
		return if gp.hidden? == true or gp.layer.visible? == false
		ot=tr * gp.transformation
		defmat=mat if mat and gp.material == nil
		defmat=gp.material if gp.material
		@used_materials << defmat
		id=gp.entityID
		name="#{id}"
        name=name + "-" + gp.name if gp.name or gp.name=""
		name.gsub!(/[^\-_0-9A-Za-z]/,"_")
		objname=title + "_g_" + name
		@matname="Default_Material"
        if defmat
			@matname=defmat.display_name.gsub(/[^\-_0-9A-Za-z]/,'_')
		end
		if gp.entities.find{|e|e.class==Sketchup::Face}
			self.export_entities(gp.entities.find_all{|e|e.class==Sketchup::Face}, objname, ot, defmat) if @obj_ or @obj_list.find{|ol| ol[0] == objname } == nil
			@obj_list << [objname, ot, @matname]
		end
        ###
		gp.entities.find_all{|e| e.class==Sketchup::Group}.each{|f| self.export_group(f, title, ot, defmat) }
	    gp.entities.find_all{|e| e.class==Sketchup::ComponentInstance}.each{|f| self.export_component_instance(f, title, ot, defmat) }
        gp.entities.find_all{|e|e.class==Sketchup::Image}.each{|ci| self.export_image(f, title, ot) }
        ###
	end
     
	def export_component_instance(ci, title="", tr=Geom::Transformation.new, mat=nil)
		return if ci.hidden? or not ci.layer.visible?
		ot=tr * ci.transformation
		defmat=mat if mat and ci.material == nil
		defmat=ci.material if ci.material
		@used_materials << defmat
		id=ci.entityID
		name=ci.definition.name
		name="#{id}" if name.length == 0
		name.gsub!(/[^\-_0-9A-Za-z]/,"_")
		objname=title + "_c_" + name
		@matname="Default_Material"
        if defmat
			@matname=defmat.display_name.gsub(/[^\-_0-9A-Za-z]/,'_')
		end
		if ci.definition.entities.find{|e| e.class==Sketchup::Face }
			self.export_entities(ci.definition.entities.find_all{|e|e.class==Sketchup::Face}, objname, ot, defmat) if @obj_ or @obj_list.find{|ol| ol[0] == objname } == nil
			@obj_list << [objname, ot, @matname]
		end
		(ci.definition.entities.find_all{|e| e.class==Sketchup::Group}).each{|f| self.export_group(f, title, ot, defmat) }
	    (ci.definition.entities.find_all{|e| e.class==Sketchup::ComponentInstance}).each{|f| self.export_component_instance(f, title, ot, defmat) }
        (ci.definition.entities.find_all{|e| e.class==Sketchup::Image}).each{|f| self.export_image(f, title, ot) }
	end
    
    def export_image(img, title="", tr=Geom::Transformation.new)
		return if img.hidden? == true or img.layer.visible? == false
        defns=@model.definitions
        defn=nil
		defns.each{|d|defn=d if d.image? and d.instances.include?(img)}
        return if not defn
        face=nil
        defn.entities.each{|e|
          if e.class==Sketchup::Face
            face=e
            break
          end#if
        }
        return if not face
		ot=tr * img.transformation
		defmat=face.material
		@used_materials << defmat
		id=img.entityID
		name="#{id}"
		name.gsub!(/[^\-_0-9A-Za-z]/,"_")
		objname=title + "_i_" + name
		@matname="Image_Material" ### should never get used !
        if defmat and defmat.name
            @matname=defmat.name.gsub(/[^\-_0-9A-Za-z]/,'_')
		end
        @img_mats<< defmat
        self.export_entities([face], objname, ot, defmat) if @obj_ or @obj_list.find{|ol| ol[0] == objname } == nil
        @obj_list << [objname, ot, @matname]
        ###
	end

	def export_entities(all_faces=[], objname="", tr=nil, defmat=nil)
        @saved_names=[]
        mats = [nil] + Sketchup.active_model.materials.to_a + @img_mats
		mats.each{|mat|
			faces=all_faces.find_all{|face|face.material==mat}
			if faces[0]
                @used_materials << mat
            else
                next
            end#if
            ###
            vs=[]
			nos=[]
			uvs=[]
			meshes=[]
			Sketchup.set_status_text("Octane Render: Processing Faces...")
            ###
			faces.each{|face|
				next if face.hidden? or not face.layer.visible?
				mesh=face.mesh(5)###7=backs too
				next if not mesh
                f_uvs=(1..mesh.count_points).map{|i|mesh.uv_at(i,1)}####1=front
                f_vs=[]
                f_vs=(1..mesh.count_points).map{|i|mesh.points[i-1]}
				f_nos=[]
                f_nos=(1..mesh.count_points).map{|i|mesh.normal_at(i)}
                f_vcount=1; f_vcount=vs.length + 1 if vs[0]
				meshes.concat(mesh.polygons.map{|p| [p.map{|px|(f_vs.index(mesh.points[(px.abs-1)]) + f_vcount)}] })
                ###
                vs.concat(f_vs) if f_vs
				uvs.concat(f_uvs) if f_uvs
				nos.concat(f_nos) if f_nos
                ###
			}#faces.each
            ###
            @vs=vs
			@nos=nos
			@uvs=uvs
			@meshes=meshes
            mat=defmat if not mat
			self.export_obj_file(objname, tr, mat)
            ######################################
		}#mats.each
	end
    
    def flattenUVQ(uvq) ### UNUSED ???
        return Geom::Point3d.new((uvq.x/uvq.z), (uvq.y/uvq.z), 1.0)
    end#flattenUVQ

	def export_obj_file(objname="", tr=nil, mat=nil)
		Sketchup.set_status_text("Octane Render: Processing Object File...")
		ot=Geom::Transformation.new
		ot=tr if tr 
        if mat
			mat_name=mat.display_name.gsub(/ /,'_').gsub(/[^_0-9A-Za-z]/,'')
            saved_name=File.basename(mat_name)
			saved_name_uniq=self.make_name_unique(@saved_names, saved_name)
			@saved_names << saved_name_uniq
            matname=saved_name_uniq
        else
            matname="Default_Material"
		end
		return if @meshes == nil
		objname=objname.gsub(/ /,'_').gsub(/[^_0-9A-Za-z]/,'')
		if @meshes.length != 0 and @vs.length != 0
			if matname
				@obj_file.puts "g #{objname}-#{matname}"
				@obj_file.puts "usemtl #{matname}"
			else
				@obj_file.puts "g #{objname}-Default_Material"
				@obj_file.puts "usemtl Default_Material"
				matname="Default_Material"
			end#if
		    @v_counter=0 if not @v_counter
			@vs.each{|v|
				v=ot * v
				@obj_file.puts "v #{"%.6f" % v.x.to_m.to_f} #{"%.6f" % v.z.to_m.to_f} #{"%.6f" % (-v.y.to_m.to_f)}"
			}
			@nos.each{|vnor|
				nor=ot * vnor
				nor.normalize!
				@obj_file.puts "vn #{"%.6f" % (nor.x)} #{"%.6f" % (nor.z)} #{"%.6f" % (-nor.y)}"
			}
			@uvs.each{|uv|
				@obj_file.puts "vt #{"%.6f" % (uv.x)} #{"%.6f" % (uv.y)}"
			}
			@meshes.each{|mesh|
				f_str="f"
				mesh.each do |pg|
					pg.each{|j|
						k=j+@v_counter
						f_str += " #{k}/#{k}/#{k}"
					}
					@obj_file.puts f_str
				end
			}
			@obj_file.puts ""
			@v_counter += @vs.length if @vs[0]
		end
		@meshes=nil
		@uvs=nil
		@nos=nil
		@vts=nil
        Sketchup.set_status_text("Octane Render: Object Completed.")
	end
    
    
	def make_texture_folder()
		@textures_path=File.join(@project_path, @textures_name) if @textures_name != ""
		Dir.mkdir(@textures_path) if not File.exist?(@textures_path)
	end
    
    
	def export_textures()
        Sketchup.set_status_text("Octane Render: Exporting Textures...")
		self.make_texture_folder()
		temp_group=Sketchup.active_model.active_entities.add_group()
		saved_names=[]
        tw=Sketchup.create_texture_writer
        mats=Sketchup.active_model.materials.to_a
        (mats + @img_mats).each{|mat|
			if mat and mat.texture
                next if not @used_materials.include?(mat)
                ### don't export unused / invisible materials for speed
				temp_group.material=mat
                mat_texture_file=mat.texture.filename.tr("\\","/")
                mat_texture_extn=File.extname(mat_texture_file)
                mat_base_bname=File.basename(mat_texture_file)
                mat_texture_basename=File.basename(mat_texture_file, mat_texture_extn)
                mat_texture_name=mat.display_name.gsub(/ /,'_').gsub(/[^_0-9A-Za-z]/,'') + mat_texture_extn
                saved_name=mat_texture_name
				saved_name_uniq=self.make_name_unique(saved_names, saved_name)
				saved_names << saved_name_uniq
                tpath=File.join(@textures_path, saved_name_uniq)
                tw.load(temp_group)
                tw.write(temp_group, tpath)
                ###
			end#if
		}
		temp_group.erase! if temp_group.valid?
		Sketchup.set_status_text("Octane Render: Textures Exported.")
	end

    
	def export_mtl_material()
        Sketchup.set_status_text("Octane Render: Making MTL File...")
        ffcol=@model.rendering_options["FaceFrontColor"]
		mtl_file=File.new(@mtl_file,"w")
        mtl_file.puts "# Alias Wavefront MTL File Exported from SketchUp by 'Octane'"
        mtl_file.puts "# (c) 2010 TIG & Refractive Software"
        mtl_file.puts "# Made for '"+@obj_name+"'"
        mtl_file.puts ""
		mtl_file.puts "newmtl Default_Material"
		mtl_file.puts "Ka 0.000000 0.000000 0.000000"
		mtl_file.puts "Kd " + ffcol.to_a[0..2].collect{|c| "%.6f" % ((c.to_f/255)) }.join(" ")
		mtl_file.puts "Ks 0.000000 0.000000 0.000000"
        mtl_file.puts "d 1.000000"
		mtl_file.puts ""
        saved_names=[]
		@used_materials.uniq!
		@used_materials.each{|mat|
			next if not mat
            mat_name=mat.display_name.gsub(/ /,'_').gsub(/[^_0-9A-Za-z]/,'')
            saved_name=File.basename(mat_name)
			saved_name_uniq=self.make_name_unique(saved_names, saved_name)
			saved_names << saved_name_uniq
            matname=saved_name_uniq
			if mat and mat.texture
                texture_extn=File.extname(mat.texture.filename)
				texture_path=@textures_name + "/" + matname + texture_extn
			end
			mtl_file.puts "newmtl #{matname}"
			if not mat.use_alpha?
				mtl_file.puts "Ka 0.000000 0.000000 0.000000"
				mtl_file.puts "Kd " + mat.color.to_a[0..2].collect{|c| "%.6f" % ((c.to_f/255)) }.join(" ")
				mtl_file.puts "Ks 0.000000 0.000000 0.000000"
				mtl_file.puts "d 1.000000"
				mtl_file.puts "map_Kd #{texture_path}" if texture_path
			else ### it's transparent
				mtl_file.puts "Ka 0.000000 0.000000 0.000000"
				mtl_file.puts "Kd " + mat.color.to_a[0..2].collect{|c| "%.6f" % ((c.to_f/255)) }.join(" ")
				mtl_file.puts "Ks 0.000000 0.000000 0.000000"
				mtl_file.puts "d #{"%.6f" % mat.alpha }"### it's NOT (1 - mat.alpha) !!!
				mtl_file.puts "map_Kd #{texture_path}" if texture_path
			end#if
            mtl_file.puts ""
		}
		mtl_file.puts "#EOF"
		mtl_file.flush
		mtl_file.close
        Sketchup.set_status_text("Octane Render: MTL File Completed.")
	end
    
	def make_name_unique(saved_names=[], saved_name="")
		if saved_names.include?(saved_name)
			counter=1
			while counter < 10000
				new_name=File.basename(saved_name, ".*") + counter.to_s + File.extname(saved_name)
				return new_name if not saved_names.include?(new_name)
				counter += 1
			end
		end
		return saved_name
	end
############## end of exporter code #########################

### start folder_browser code ###

    def startfb(dir=nil, input=nil)
        @octane_render_folder_browser_result = nil
        begin
          Dir.chdir(dir) if dir
        rescue
          UI.messagebox("Can't Change Directory to:\n"+dir)
        end
		@dlgfb=UI::WebDialog.new("Browse for Folder >> Highlight >> OK",false,"Octane_FolderBrowser",350,350,50,50,false)
		file=File.join(File.dirname(__FILE__),"OctaneFolderBrowser/folder_browser.html")
		@dlgfb.set_file(file)
        @dlgfb.min_width=350
        @dlgfb.add_action_callback("jserr"){|d,a|UI.messagebox("ERROR:\n"+a)}
        @dlgfb.add_action_callback("mkdir"){|d,a|self.newfolder(Dir.pwd)}
        @dlgfb.add_action_callback("cancel"){|d,a|d.close}
        @dlgfb.add_action_callback("alert"){|d,a|UI.messagebox("Highlight a Folder!")}
		@dlgfb.add_action_callback("folder"){|d,a|
			pwd=Dir.pwd
            begin
			  Dir.chdir(a)
            rescue
              UI.messagebox("Can't Change Directory to:\n"+a)
            end
			new_d=File.join(Dir.pwd,"*")
			d.execute_script('clear_list()')
			self.populatefb(Dir.pwd)
		}
		@dlgfb.add_action_callback("use_this"){|d,a|
            @octane_render_folder_browser_result = a
			d.close
            if input == "image"
              self.update_image()
            elsif input == "project"
              self.update_project()
            end#if
		}
        ###
        @dlgfb.set_on_close{@dlgfb=nil}### nullify itself!
		###@dlgfb.show{sleep(0.1); self.populatefb()}### can't be BOTH!
        @dlgfb.show_modal{self.populatefb()} #sleep(0.1); 
	end
    ###
    def newfolder(dir=nil)
        results=UI.inputbox(["New Folder Name "],[""],"")
        return nil if not results
        newDir=results[0]
        return nil if not newDir or newDir==""
        newDir.gsub!(/[^_A-Za-z0-9]/,'')### strip out
        if not newDir or newDir==""
          UI.messagebox("Folder's Name Must Contain Only _A-Za-z0-9")
          return nil
        end#if
        dir=Dir.pwd if not dir
        begin
          Dir.chdir(dir)
        rescue
          UI.messagebox("Can't Change Directory to:\n"+dir)
        end
        if File.exist?(newDir)
          UI.messagebox("It Already Exists!")
          return nil
        else
          Dir.mkdir(newDir)
          @dlgfb.execute_script('clear_list()')
          self.populatefb(Dir.pwd, newDir)
        end#if
    end
    ###
	def populatefb(dir=nil, newDir=nil)
		list=[]
		dir=Dir.pwd if not dir
        begin
		  Dir.chdir(dir)
        rescue
          UI.messagebox("Can't Change Directory to:\n"+dir)
        end
		pwd=Dir.pwd
		@dlgfb.execute_script('set_location("'+pwd+'");')
		Dir[pwd+"/*"].sort.each{|file|
			next unless File.directory?(file)
			list << file if File.basename(file) != newDir
		}
		scr='appendDiv("../");'
		@dlgfb.execute_script(scr)
        scr='appendDiv("'+newDir+'");' if newDir
		@dlgfb.execute_script(scr) if newDir
		list.each{|name|
			name=File.basename(name)
			scr='appendDiv("'+name+'");'
			@dlgfb.execute_script(scr)
		}
	end

####################### end fb ###
  
end#class Octane ##########################################################
###

### make shortcut to tool #################################################
def octane()
  Sketchup.active_model.select_tool(Octane.new)
end#def octane
###


### add menu item etc #####################################################
if not file_loaded?(File.basename(__FILE__))
  ### make command
  cmd=UI::Command.new("Octane Render..."){octane}
  cmd.tooltip="Octane Render..."
  cmd.status_bar_text="Opens the 'Octane Render' dialog to export/render the model..."
  ### menu
  UI.menu("File").add_item(cmd)
  ### context menu
  UI.add_context_menu_handler do |menu|
    menu.add_item(cmd)
  end#do menu
  ### toolbar
  toolbar=UI::Toolbar.new("Octane Render")
  toolbar.restore if toolbar.get_last_state==TB_VISIBLE
  cmd.small_icon="Octane/OctaneToolbar16x16.png"
  cmd.large_icon="Octane/OctaneToolbar24x24.png"
  toolbar.add_item(cmd)
  ###
  file_loaded(File.basename(__FILE__))
end#if
###